unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, BufDataset, sqldb, FileUtil, Forms, Controls, Graphics,
  Dialogs, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure BufDataset1AfterOpen(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);

  function RandomString: String;
  const
    Str = ' abcdefghijklmnopqrstuvwxyz';
  var
    i: Integer;
  begin
    SetLength(Result, Random(200));
    for i := 1 to Length(Result) do
      Result[i] := Str[Random(Length(Str)) + 1];
  end;
  procedure FillRandomData;
  var
    i: Integer;
  begin
    for i := 0 to 99 do begin
      BufDataset1.Insert;
      BufDataset1.Fields[0].AsString := RandomString;
      BufDataset1.Fields[1].AsString := 'Data2 - ' + IntToStr(i);
    end;
  end;

begin
  BufDataset1.CreateDataset;
  FillRandomData;
  BufDataset1.Active := True;
end;

procedure TForm1.BufDataset1AfterOpen(DataSet: TDataSet);
var
  i: Integer;
begin
  for i := 0 to BufDataset1.FieldCount - 1 do
    DBGrid1.Columns[i].Width := 2 * ClientWidth;
end;

end.

